Getting Started with React Grid Component

Smart UI React targets React 18+ and current Node LTS for tooling; use TypeScript templates when you want typed props and events.

Demo source (Smart UI repo): react/source/grid/overview/App.jsx


Data Grid

1 Create a Vite + React + TypeScript app

  1. npm create vite@latest my-smart-app -- --template react-ts
  2. cd my-smart-app
    then
    npm install

2 Install Smart UI for React

npm install smart-webcomponents-react

3 Import styles and render the component

Open src/App.tsx (or App.jsx if you chose JavaScript). The snippet below matches Smart UI React demos for this widget:

import 'smart-webcomponents-react/source/styles/smart.default.css';
import { Grid } from 'smart-webcomponents-react/grid';

const dataSource = [
  { id: 1, firstName: 'Andrew', lastName: 'Fuller', productName: 'Black Tea', available: true, date: '2026-01-01', quantity: 10, price: 2.5, total: 25 },
  { id: 2, firstName: 'Nancy', lastName: 'Davolio', productName: 'Green Tea', available: false, date: '2026-01-01', quantity: 5, price: 3.0, total: 15 },
  { id: 3, firstName: 'John', lastName: 'Doe', productName: 'White Tea', available: true, date: '2026-01-01', quantity: 8, price: 2.0, total: 16 }
];

const dataSourceSettings = {
  dataFields: [
    'id: number', 'firstName: string', 'lastName: string', 'productName: string',
    'available: boolean', 'date: date', 'quantity: number', 'price: number', 'total: number'
  ]
};

const columns = [
  { label: 'First Name', dataField: 'firstName', editor: { required: true, template: 'input' } },
  { label: 'Last Name', dataField: 'lastName', editor: { required: true, template: 'input' } },
  { label: 'Product', width: 200, dataField: 'productName', editor: { required: true, template: 'dropDownList' } },
  { label: 'Available', dataField: 'available', template: 'checkBox', editor: 'checkBox' },
  { label: 'Quantity', dataField: 'quantity', editor: 'numberInput' },
  { label: 'Unit Price', dataField: 'price', editor: 'numberInput', cellsFormat: 'c2' }
];

export default function App() {
  return (
    <Grid
      dataSource={dataSource}
      dataSourceSettings={dataSourceSettings}
      columns={columns}
      sortable
      filterable
      editable
      columnResize
      selectable
    />
  );
}

4 Run the dev server

npm run dev

Open the URL Vite prints (often http://localhost:5173/).

Alternative: Next.js

Create an app with npx create-next-app@latest (Pages Router or App Router). Install the same package (npm install smart-webcomponents-react), then reuse the imports and default export from step 3 in pages/_app.tsx, the App Router root app/layout.tsx, or your top-level layout component so styles and the widget tree load once.

Common Use Cases

  • Load data from REST API

    Fetch JSON data and bind to the grid dynamically

    const response = await fetch('/api/data');
    const data = await response.json();
    grid.dataSource = data;
  • Enable inline cell editing

    Allow users to edit cells directly in the grid

    grid.editing = { enabled: true, mode: 'cell' };
  • Export to Excel

    Export grid data to an Excel file

    grid.exportData('xlsx', 'GridExport');
  • Apply column filtering

    Enable filter row for column-based filtering

    grid.filtering = { enabled: true, filterRow: { visible: true } };

Troubleshooting

How do I update grid data in React?
Use useState for dataSource and update it with setDataSource(newData). The Grid component will re-render automatically.
How do I access the grid instance in React?
Use a ref: const gridRef = useRef(); then access via gridRef.current after mount.

TypeScript Support

Types ship with smart-webcomponents-react. Import the component and prop types:

import type { Grid, GridProps } from 'smart-webcomponents-react/grid';

The generated wrappers expose on* callbacks (for example onChange) whose arguments are standard DOM Event values unless the widget typings narrow them further.

Accessibility

The Grid component follows WAI-ARIA best practices:

  • Keyboard navigation - Tab, Arrow keys, Enter, and Escape are supported
  • ARIA roles - Appropriate roles and labels are applied automatically
  • Focus management - Visible focus indicators for keyboard users
  • Screen readers - State changes are announced to assistive technology
  • High contrast - Supports Windows High Contrast Mode and forced colors

For custom labeling, set aria-label or aria-labelledby attributes on the component.

Live demos

Supported stacks: Smart UI targets Angular 17+, React 18+, Vue 3+, Node 18 LTS, and evergreen browsers; pin exact package versions to your org policy.

Getting Started with Vue Grid Component

Smart UI Vue examples target Vue 3 and Vite; enable TypeScript in create-vue when you want typed SFCs.

Demo source (Smart UI repo): vue/vue-3/src/grid/overview/App.vue


Data Grid

Scaffold with Vite (Vue 3)

Run the official scaffolding tool:

npm create vue@latest

You will be prompted for TypeScript, Router, Pinia, and other options. When unsure, accept defaults and enable features later.

cd <your-project-name>
npm install
npm install smart-webcomponents
npm run dev
	

Vue + TypeScript

If you enabled TypeScript, use vite.config.ts with the same isCustomElement configuration as below so the compiler treats Smart UI tags as native custom elements.

Teach Vue about custom elements

Without this, Vue warns about unknown custom elements. Open vite.config.js or vite.config.ts and configure the Vue plugin so smart-* and legacy jqx-* tags are passed through to the DOM:

import { fileURLToPath, URL } from 'node:url'

import { defineConfig } from 'vite'
import vue from '@vitejs/plugin-vue'

export default defineConfig({
  plugins: [
    vue({
      template: {
        compilerOptions: {
          isCustomElement: tag => tag.startsWith('smart-') || tag.startsWith('jqx-')
        }
      }
    })
  ],
  resolve: {
    alias: {
      '@': fileURLToPath(new URL('./src', import.meta.url))
    }
  }
})
	

App.vue example

Example from Smart UI Vue 3 demos for this widget:

<template>
  <smart-grid
    :dataSource="dataSource"
    :dataSourceSettings="dataSourceSettings"
    :columns="columns"
    sortable
    filterable
    editable
    column-resize
    selectable>
  </smart-grid>
</template>

<script setup>
import 'smart-webcomponents/source/styles/smart.default.css';
import 'smart-webcomponents/source/modules/smart.grid.js';

const dataSource = [
  { id: 1, firstName: 'Andrew', lastName: 'Fuller', productName: 'Black Tea', available: true, date: '2026-01-01', quantity: 10, price: 2.5, total: 25 },
  { id: 2, firstName: 'Nancy', lastName: 'Davolio', productName: 'Green Tea', available: false, date: '2026-01-01', quantity: 5, price: 3.0, total: 15 },
  { id: 3, firstName: 'John', lastName: 'Doe', productName: 'White Tea', available: true, date: '2026-01-01', quantity: 8, price: 2.0, total: 16 }
];

const dataSourceSettings = {
  dataFields: [
    'id: number', 'firstName: string', 'lastName: string', 'productName: string',
    'available: boolean', 'date: date', 'quantity: number', 'price: number', 'total: number'
  ]
};

const columns = [
  { label: 'First Name', dataField: 'firstName', editor: { required: true, template: 'input' } },
  { label: 'Last Name', dataField: 'lastName', editor: { required: true, template: 'input' } },
  { label: 'Product', width: 200, dataField: 'productName', editor: { required: true, template: 'dropDownList' } },
  { label: 'Available', dataField: 'available', template: 'checkBox', editor: 'checkBox' },
  { label: 'Quantity', dataField: 'quantity', editor: 'numberInput' },
  { label: 'Unit Price', dataField: 'price', editor: 'numberInput', cellsFormat: 'c2' }
];
</script>
	

You can now use smart-grid in templates; bindings and events follow Vue's normal syntax.

Run and build

Development server:

npm run dev

Then open http://localhost:5173/.

Production build:

npm run build

Output goes to ./dist.

Read more about using Smart UI for Vue.

Common Use Cases

  • Load data from REST API

    Fetch JSON data and bind to the grid dynamically

    const response = await fetch('/api/data');
    const data = await response.json();
    grid.dataSource = data;
  • Enable inline cell editing

    Allow users to edit cells directly in the grid

    grid.editing = { enabled: true, mode: 'cell' };
  • Export to Excel

    Export grid data to an Excel file

    grid.exportData('xlsx', 'GridExport');
  • Apply column filtering

    Enable filter row for column-based filtering

    grid.filtering = { enabled: true, filterRow: { visible: true } };

Troubleshooting

Why does Vue warn about unknown custom element?
Configure isCustomElement in vite.config.js so smart-* and legacy jqx-* tags are native custom elements, e.g. isCustomElement: tag => tag.startsWith('smart-') || tag.startsWith('jqx-').

Accessibility

The Grid component follows WAI-ARIA best practices:

  • Keyboard navigation - Tab, Arrow keys, Enter, and Escape are supported
  • ARIA roles - Appropriate roles and labels are applied automatically
  • Focus management - Visible focus indicators for keyboard users
  • Screen readers - State changes are announced to assistive technology
  • High contrast - Supports Windows High Contrast Mode and forced colors

For custom labeling, set aria-label or aria-labelledby attributes on the component.

Live demos

Supported stacks: Smart UI targets Angular 17+, React 18+, Vue 3+, Node 18 LTS, and evergreen browsers; pin exact package versions to your org policy.

Angular Grid - Setup

Smart UI for Angular supports both standalone components (bootstrapApplication) and NgModule-based apps (bootstrapModule(AppModule)). Steps 1-5 show the standalone path; the section below shows the NgModule path with the same package and styles.

Demo source (Smart UI repo): angular/src/grid/overview


Data Grid

1 NPM Install

Install the smart-webcomponents-angular package:

npm install smart-webcomponents-angular

2 Register styles

Add the default Smart UI stylesheet to angular.json -> projects -> <your-project> -> architect -> build -> options -> styles (merge with existing entries):

"styles": [
		"node_modules/smart-webcomponents-angular/source/styles/smart.default.css"
	]

Add optional theme CSS from the same package after smart.default.css if you use Bootstrap, Fluent, or other bundled themes.

3 Import the Angular module

Import GridModule from smart-webcomponents-angular/grid: use @Component.imports for standalone, or add it to your AppModule (or feature module) imports array for NgModule apps.

import { GridModule } from 'smart-webcomponents-angular/grid';

4 Root component (standalone)

Add GridModule to your root standalone component (src/app/app.ts). Snippet from Smart UI demos (paths normalized to app.html / App where applicable):

 import { Component } from '@angular/core';
import { GridModule } from 'smart-webcomponents-angular/grid';

@Component({
  selector: 'app-root',
  standalone: true,
  imports: [GridModule],
  templateUrl: './app.html',
  styleUrls: ['./app.css']
})
export class App {
  dataSource = [
    { id: 1, firstName: 'Andrew', lastName: 'Fuller', productName: 'Black Tea', available: true, date: '2026-01-01', quantity: 10, price: 2.5, total: 25 },
    { id: 2, firstName: 'Nancy', lastName: 'Davolio', productName: 'Green Tea', available: false, date: '2026-01-01', quantity: 5, price: 3.0, total: 15 },
    { id: 3, firstName: 'John', lastName: 'Doe', productName: 'White Tea', available: true, date: '2026-01-01', quantity: 8, price: 2.0, total: 16 }
  ];

  dataSourceSettings = {
    dataFields: [
      'id: number',
      'firstName: string',
      'lastName: string',
      'productName: string',
      'available: boolean',
      'date: date',
      'quantity: number',
      'price: number',
      'total: number'
    ]
  };

  columns = [
    { label: 'First Name', dataField: 'firstName', editor: { required: true, template: 'input' } },
    { label: 'Last Name', dataField: 'lastName', editor: { required: true, template: 'input' } },
    { label: 'Product', width: 200, dataField: 'productName', editor: { required: true, template: 'dropDownList' } },
    { label: 'Available', dataField: 'available', template: 'checkBox', editor: 'checkBox' },
    { label: 'Quantity', dataField: 'quantity', editor: 'numberInput' },
    { label: 'Unit Price', dataField: 'price', editor: 'numberInput', cellsFormat: 'c2' }
  ];
}

Boot the app with bootstrapApplication from src/main.ts and an ApplicationConfig in src/app/app.config.ts as generated by the CLI.

5 Template (standalone)

Use your markup in src/app/app.html (or inline template). Bind properties and events on smart-grid as needed:

 <smart-grid
  [dataSource]="dataSource"
  [dataSourceSettings]="dataSourceSettings"
  [columns]="columns"
  [sortable]="true"
  [filterable]="true"
  [editable]="true"
  [columnResize]="true"
  [selectable]="true">
</smart-grid>

6 NgModule bootstrap (also supported)

Same npm package and angular.json styles as steps 1-2. Put GridModule on your NgModule.imports instead of @Component.imports, and bootstrap with bootstrapModule(AppModule).

NgModule is also supported: put GridModule from smart-webcomponents-angular/grid on NgModule.imports instead of @Component.imports.

Run

ng serve or npm start - then open http://localhost:4200/.

Smart UI for Angular - full documentation

Common Use Cases

  • Load data from REST API

    Fetch JSON data and bind to the grid dynamically

    const response = await fetch('/api/data');
    const data = await response.json();
    grid.dataSource = data;
  • Enable inline cell editing

    Allow users to edit cells directly in the grid

    grid.editing = { enabled: true, mode: 'cell' };
  • Export to Excel

    Export grid data to an Excel file

    grid.exportData('xlsx', 'GridExport');
  • Apply column filtering

    Enable filter row for column-based filtering

    grid.filtering = { enabled: true, filterRow: { visible: true } };

Troubleshooting

How do I bind grid events in Angular?
Use Angular event binding syntax: (onChange)="onGridChange($event)" or add event listeners in ngAfterViewInit using @ViewChild to access the grid element.
Why do I get 'smart-grid is not a known element' error?
Import GridModule from 'smart-webcomponents-angular/grid' in your component's imports array (standalone) or AppModule imports.

Accessibility

The Grid component follows WAI-ARIA best practices:

  • Keyboard navigation - Tab, Arrow keys, Enter, and Escape are supported
  • ARIA roles - Appropriate roles and labels are applied automatically
  • Focus management - Visible focus indicators for keyboard users
  • Screen readers - State changes are announced to assistive technology
  • High contrast - Supports Windows High Contrast Mode and forced colors

For custom labeling, set aria-label or aria-labelledby attributes on the component.

Live demos

Supported stacks: Smart UI targets Angular 17+, React 18+, Vue 3+, Node 18 LTS, and evergreen browsers; pin exact package versions to your org policy.